/************************************************************************
 This file is part of Desk-Weather.
 Desk-Weather is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 Desk-Weather is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 You should have received a copy of the GNU General Public License
 along with Desk-Weather.  If not, see <http://www.gnu.org/licenses/>.
 *************************************************************************/


/// Work Around for Ext 2.2 bug ////

Ext.form.Checkbox.override({
    setValue : function(v) {
        var checked = this.checked;
        this.checked = (v === true || v === 'true' || v == '1' || String(v).toLowerCase() == 'on');
        
        if(this.rendered){
            this.el.dom.checked = this.checked;
            this.el.dom.defaultChecked = this.checked;
            this.wrap[this.checked? 'addClass' : 'removeClass'](this.checkedCls);
        }
        
        if(checked != this.checked){
            this.fireEvent("check", this, this.checked);
            if(this.handler){
                this.handler.call(this.scope || this, this, this.checked);
            }
        }
    },

    afterRender : function(){
        Ext.form.Checkbox.superclass.afterRender.call(this);
        this.wrap[this.checked? 'addClass' : 'removeClass'](this.checkedCls);
    }
});

/// End of Work Around ///

Ext.ux.DeskWeatherSearchField = Ext.extend(Ext.form.TwinTriggerField, {
 initComponent : function() {
   Ext.ux.DeskWeatherSearchField.superclass.initComponent.call(this);
   this.on('specialkey', function(f, e){
     if(e.getKey() == e.ENTER){
       this.onTrigger2Click();
     }
   }, this);
 },

 validationEvent:false,
 validateOnBlur:false,
 trigger1Class:'x-form-clear-trigger',
 trigger2Class:'x-form-search-trigger',
 hideTrigger1:true,
 width:180,
 hasSearch : false,
 paramName : 'q',

 onTrigger1Click : function(){
         if(this.hasSearch){
                 this.el.dom.value = '';
                 this.store.reload();
                 this.triggers[0].hide();
                 this.hasSearch = false;
         }
 },

 onTrigger2Click : function(){
       var v = this.getRawValue();
       if(v.length < 1){
                this.onTrigger1Click();
                return;
       }
       this.store.load({params: {'q':v}});
       this.hasSearch = true;
       this.triggers[0].show();
}
});


QoDesk.DeskWeatherCity = Ext.extend(Ext.app.Module, {
    units:'metric',
    IdentCity:'',
    LibelCity:'',
    fromWhere:'',
    winAbout:'',
    init : function(){
        this.launcher = {
            text: '',
            iconCls:'DeskWeather-icon',
            handler : this.createWindow,
            scope: this
        };
    },
    createWindow : function(app, cIdentCity, cLibelCity, units, fromWhere){
        this.units = units;
        this.IdentCity = cIdentCity;
        this.LibelCity = cLibelCity;
        this.fromWhere = fromWhere;
        this.app = app;
        var desktop = this.app.getDesktop();
        var win = desktop.getWindow('desk-weather-local-win-'+cIdentCity);

        if( !win) {

           var mainPanel = new Ext.Panel({
            title :'-',
            id: this.IdentCity+'-id-panel',
            height: 170,
            tools: [{
              scope: this,
              id:'refresh',
              qtip:DeskWeatherLocalString.ReloadData,
              handler: function() {
               this.loadData(cIdentCity);
              }

            },{
              scope: this,
              id:'gear',
              qtip:DeskWeatherLocalString.ConfCity,
              handler: this.showConf
            }],
            layout:'table',
            layoutConfig: {
                columns: 4
            },
            items: [
            {
                html: '<div id="'+this.IdentCity+'-img-big">-</div>',
                rowspan: 2,
                width: 128,
                border: false
            },{
                html: '<p id="'+this.IdentCity+'-tmp-big" class="DeskWeather-info-value-big">-</p>',
                border: false
            },{
                html: ' ',
                width: 22,
                border: false
            },{
                html: '<div id="'+this.IdentCity+'-img-night" class="DeskWeather-icon-night">-</div>',
                border: false
            },{
                html: '<p class="DeskWeather-info-libel">' + DeskWeatherLocalString.InfoFeelsLike + '<span id="'+this.IdentCity+'-info-tmp-ressenti" class="DeskWeather-info-value">-</span></p>'+
                      '<p class="DeskWeather-info-libel">' + DeskWeatherLocalString.InfoWind + '<span id="'+this.IdentCity+'-info-wind" class="DeskWeather-info-value">-</span></p>'+
                      '<p class="DeskWeather-info-libel">' + DeskWeatherLocalString.InfoDewPoint + '<span id="'+this.IdentCity+'-info-dewp" class="DeskWeather-info-value">-</span></p>'+
                      '<p class="DeskWeather-info-libel">' + DeskWeatherLocalString.InfoHumidity + '<span id="'+this.IdentCity+'-info-humidity" class="DeskWeather-info-value">-</span></p>',
                width: 160,
                border: false
            },{
                html: '<img src="system/modules/Desk-Weather/img/filet.png" alt="" />',
                border: false
            },{
                html: '<p class="DeskWeather-info-libel">' + DeskWeatherLocalString.InfoNight + '<span id="'+this.IdentCity+'-info-tmp-night" class="DeskWeather-info-value">-</span></p>'+
                      '<p class="DeskWeather-info-libel">' + DeskWeatherLocalString.InfoVisilibity + '<span id="'+this.IdentCity+'-info-visibility" class="DeskWeather-info-value">-</span></p>'+
                      '<p class="DeskWeather-info-libel">' + DeskWeatherLocalString.InfoPressure + '<span id="'+this.IdentCity+'-info-bar" class="DeskWeather-info-value">-</span></p>'+
                      '<p class="DeskWeather-info-libel">' + DeskWeatherLocalString.InfoUVIndex + '<span id="'+this.IdentCity+'-info-uv" class="DeskWeather-info-value">-</span></p>',
                width: 160,
                border: false
            }]
           });

           var nextDayPanel = new Ext.Panel({
               layout:'column',
               border: false,
               defaults: { bodyStyle:'padding:2px'},
               items: [{
                   columnWidth: .25,
                   border: false,
                   items: [{
                    xtype:'fieldset',
                    bodyStyle:'text-align:center;',
                    title:'-',
                    id: cIdentCity+'-libel-day-1',
                    height:100,
                    html:'<div id="'+this.IdentCity+'-img-day-1">-</div>'

                   }]
               },{
                   columnWidth: .25,
                   border: false,
                   items: [{
                    xtype:'fieldset',
                    bodyStyle:'text-align:center;',
                    title:'-',
                    id: cIdentCity+'-libel-day-2',
                    height:100,
                    html:'<div id="'+this.IdentCity+'-img-day-2">-</div>'

                   }]
               },{
                   columnWidth: .25,
                   border: false,
                   items: [{
                    xtype:'fieldset',
                    bodyStyle:'text-align:center;',
                    title:'-',
                    id: cIdentCity+'-libel-day-3',
                    height:100,
                    html:'<div id="'+this.IdentCity+'-img-day-3">-</div>'

                   }]
               },{
                   columnWidth: .25,
                   border: false,
                   items: [{
                    xtype:'fieldset',
                    bodyStyle:'text-align:center;',
                    title:'-',
                    id: cIdentCity+'-libel-day-4',
                    height:100,
                    html:'<div id="'+this.IdentCity+'-img-day-4">-</div>'

                   }]
               }]
           });

            win = desktop.createWindow({
                id: 'desk-weather-local-win-'+this.IdentCity,
                title: this.LibelCity,
                width:500,
                height:315,
                maximizable: false,
                resizable: false,
                x:100,
                y:50,
                iconCls: 'DeskWeather-icon',
                shim:false,
                animCollapse:false,
                constrainHeader:true,
                layout: 'fit',
                items: [{
                    region: 'center',
                    id: this.IdentCity + 'center-panel',
                    bodyStyle: 'padding:5px;',
                    items:[mainPanel,nextDayPanel]
                  }]
            });

            this.loadData(cIdentCity);


        }
        win.show();
    },

    loadData : function() {

       Ext.get('desk-weather-local-win-'+this.IdentCity).mask(DeskWeatherLocalString.LoadingData);

       var loadDataConnexion = new Ext.data.Connection();
       loadDataConnexion.request({
           scope: this,
           url: this.app.connection,
           params: {
               moduleId: 'desk-weather',
               fileName: 'php/get-info.php',
               city: this.IdentCity
           },

           success: function(response, options) {

               var o = Ext.util.JSON.decode(response.responseText);

               this.setData(o.data);

               Ext.get('desk-weather-local-win-'+this.IdentCity).unmask();

           }
       });


    },

    setData : function(o) {

    // Title & Icon Window
    Ext.getCmp('desk-weather-local-win-'+this.IdentCity).setTitle(((this.units == 'english')? o.cc.tmp.english : o.cc.tmp.metric )+' - '+this.LibelCity, 'DeskWeather-icon-'+o.cc.icon);

    // Title panel
    var titlePanel = String.format(DeskWeatherLocalString.TitlePanelCity, DeskWeatherLocalString.Today, DeskWeatherLocalDay[o.lastupdate.num_day],o.lastupdate.d,DeskWeatherLocalMonth[o.lastupdate.num_month],o.lastupdate.y,o.lastupdate.hour);

    Ext.getCmp(this.IdentCity+'-id-panel').setTitle(titlePanel);
    Ext.getDom(this.IdentCity+'-img-big').innerHTML = '<img src="system/modules/Desk-Weather/img/default/128x128/'+ o.cc.icon +'.png" alt="" />';
    Ext.getDom(this.IdentCity+'-tmp-big').innerHTML = ((this.units == 'english')? o.cc.tmp.english : o.cc.tmp.metric );
    Ext.getDom(this.IdentCity+'-img-night').innerHTML = '<img src="system/modules/Desk-Weather/img/default/128x128/'+ o.cc.night_icon +'.png" width="68" height="68" alt="" />';
    Ext.getDom(this.IdentCity+'-info-tmp-ressenti').innerHTML = ((this.units == 'english')? o.cc.tmp_ressenti.english : o.cc.tmp_ressenti.metric );
    Ext.getDom(this.IdentCity+'-info-wind').innerHTML = ((this.units == 'english')? o.cc.wind_speed.english : o.cc.wind_speed.metric ) + ' / '+ ( (DeskWeatherLocalWindDirection[o.cc.wind_direction])? DeskWeatherLocalWindDirection[o.cc.wind_direction] : o.cc.wind_direction );
    Ext.getDom(this.IdentCity+'-info-dewp').innerHTML = ((this.units == 'english')? o.cc.dewp.english : o.cc.dewp.metric );
    Ext.getDom(this.IdentCity+'-info-humidity').innerHTML = o.cc.humidity;
    Ext.getDom(this.IdentCity+'-info-tmp-night').innerHTML = ((this.units == 'english')? o.cc.tmp_night.english : o.cc.tmp_night.metric );
    Ext.getDom(this.IdentCity+'-info-visibility').innerHTML = ((this.units == 'english')? o.cc.visibility.english : o.cc.visibility.metric );
    Ext.getDom(this.IdentCity+'-info-bar').innerHTML = ((this.units == 'english')? o.cc.bar.english : o.cc.bar.metric );
    Ext.getDom(this.IdentCity+'-info-uv').innerHTML = o.cc.uv_value+' - ' + ( (DeskWeatherLocalUV[o.cc.uv_libel])? DeskWeatherLocalUV[o.cc.uv_libel] : o.cc.uv_libel );
    Ext.getCmp(this.IdentCity+'-libel-day-1').setTitle(DeskWeatherLocalDay[o[1].day.origin]);
    Ext.getCmp(this.IdentCity+'-libel-day-2').setTitle(DeskWeatherLocalDay[o[2].day.origin]);
    Ext.getCmp(this.IdentCity+'-libel-day-3').setTitle(DeskWeatherLocalDay[o[3].day.origin]);
    Ext.getCmp(this.IdentCity+'-libel-day-4').setTitle(DeskWeatherLocalDay[o[4].day.origin]);
    Ext.getDom(this.IdentCity+'-img-day-1').innerHTML = '<img id="' + this.IdentCity + '-img2-day-1" src="system/modules/Desk-Weather/img/default/128x128/'+ o[1].icon +'.png" width="68" height="68" alt="" />';
    Ext.getDom(this.IdentCity+'-img-day-2').innerHTML = '<img id="' + this.IdentCity + '-img2-day-2" src="system/modules/Desk-Weather/img/default/128x128/'+ o[2].icon +'.png" width="68" height="68" alt="" />';
    Ext.getDom(this.IdentCity+'-img-day-3').innerHTML = '<img id="' + this.IdentCity + '-img2-day-3" src="system/modules/Desk-Weather/img/default/128x128/'+ o[3].icon +'.png" width="68" height="68" alt="" />';
    Ext.getDom(this.IdentCity+'-img-day-4').innerHTML = '<img id="' + this.IdentCity + '-img2-day-4" src="system/modules/Desk-Weather/img/default/128x128/'+ o[4].icon +'.png" width="68" height="68" alt="" />';

    // Qtips for prevision
    Ext.QuickTips.register({
      target: Ext.get(this.IdentCity+'-img2-day-1'),
      trackMouse: true,
      title: '',
      text: '<table><tr><td><img src="system/modules/Desk-Weather/img/default/128x128/'+ o[1].icon +'.png" width="68" height="68" alt="" /></td><td class="DeskWeather-spacer"><img src="system/modules/Desk-Weather/img/filet.png" alt="" /></td><td><div class="DeskWeather-ForeCast-info"><p class="DeskWeather-ForeCast-info-libel">'+DeskWeatherLocalString.InfoTempMin+'<span class="DeskWeather-ForeCast-info-value">'+ ((this.units == 'english')? o[1].tmp.low.english : o[1].tmp.low.metric ) +'</span></p><p class="DeskWeather-ForeCast-info-libel">'+DeskWeatherLocalString.InfoTempMax+'<span class="DeskWeather-ForeCast-info-value">'+((this.units == 'english')? o[1].tmp.hi.english : o[1].tmp.hi.metric )+'</span></p><p class="DeskWeather-ForeCast-info-libel">'+DeskWeatherLocalString.InfoChanceOfRain+'<span class="DeskWeather-ForeCast-info-value">'+o[1].ppcp+'</span></p><p class="DeskWeather-ForeCast-info-libel">'+DeskWeatherLocalString.InfoHumidity+'<span class="DeskWeather-ForeCast-info-value">'+o[1].humidity+'</span></p></div></td></tr></table>',
      cls : 'DeskWeather-ForeCast',
      width: 300
    });
    Ext.QuickTips.register({
      target: Ext.get(this.IdentCity+'-img2-day-2'),
      trackMouse: true,
      title: '',
      text: '<table><tr><td><img src="system/modules/Desk-Weather/img/default/128x128/'+ o[2].icon +'.png" width="68" height="68" alt="" /></td><td class="DeskWeather-spacer"><img src="system/modules/Desk-Weather/img/filet.png" alt="" /></td><td><div class="DeskWeather-ForeCast-info"><p class="DeskWeather-ForeCast-info-libel">'+DeskWeatherLocalString.InfoTempMin+'<span class="DeskWeather-ForeCast-info-value">'+ ((this.units == 'english')? o[2].tmp.low.english : o[2].tmp.low.metric ) +'</span></p><p class="DeskWeather-ForeCast-info-libel">'+DeskWeatherLocalString.InfoTempMax+'<span class="DeskWeather-ForeCast-info-value">'+((this.units == 'english')? o[2].tmp.hi.english : o[2].tmp.hi.metric )+'</span></p><p class="DeskWeather-ForeCast-info-libel">'+DeskWeatherLocalString.InfoChanceOfRain+'<span class="DeskWeather-ForeCast-info-value">'+o[2].ppcp+'</span></p><p class="DeskWeather-ForeCast-info-libel">'+DeskWeatherLocalString.InfoHumidity+'<span class="DeskWeather-ForeCast-info-value">'+o[2].humidity+'</span></p></div></td></tr></table>',
      cls : 'DeskWeather-ForeCast',
      width: 300
    });
    Ext.QuickTips.register({
      target: Ext.get(this.IdentCity+'-img2-day-3'),
      trackMouse: true,
      title: '',
      text: '<table><tr><td><img src="system/modules/Desk-Weather/img/default/128x128/'+ o[3].icon +'.png" width="68" height="68" alt="" /></td><td class="DeskWeather-spacer"><img src="system/modules/Desk-Weather/img/filet.png" alt="" /></td><td><div class="DeskWeather-ForeCast-info"><p class="DeskWeather-ForeCast-info-libel">'+DeskWeatherLocalString.InfoTempMin+'<span class="DeskWeather-ForeCast-info-value">'+ ((this.units == 'english')? o[3].tmp.low.english : o[3].tmp.low.metric ) +'</span></p><p class="DeskWeather-ForeCast-info-libel">'+DeskWeatherLocalString.InfoTempMax+'<span class="DeskWeather-ForeCast-info-value">'+((this.units == 'english')? o[3].tmp.hi.english : o[3].tmp.hi.metric )+'</span></p><p class="DeskWeather-ForeCast-info-libel">'+DeskWeatherLocalString.InfoChanceOfRain+'<span class="DeskWeather-ForeCast-info-value">'+o[3].ppcp+'</span></p><p class="DeskWeather-ForeCast-info-libel">'+DeskWeatherLocalString.InfoHumidity+'<span class="DeskWeather-ForeCast-info-value">'+o[3].humidity+'</span></p></div></td></tr></table>',
      cls : 'DeskWeather-ForeCast',
      width: 300
    });
    Ext.QuickTips.register({
      target: Ext.get(this.IdentCity+'-img2-day-4'),
      trackMouse: true,
      title: '',
      text: '<table><tr><td><img src="system/modules/Desk-Weather/img/default/128x128/'+ o[4].icon +'.png" width="68" height="68" alt="" /></td><td class="DeskWeather-spacer"><img src="system/modules/Desk-Weather/img/filet.png" alt="" /></td><td><div class="DeskWeather-ForeCast-info"><p class="DeskWeather-ForeCast-info-libel">'+DeskWeatherLocalString.InfoTempMin+'<span class="DeskWeather-ForeCast-info-value">'+ ((this.units == 'english')? o[4].tmp.low.english : o[4].tmp.low.metric ) +'</span></p><p class="DeskWeather-ForeCast-info-libel">'+DeskWeatherLocalString.InfoTempMax+'<span class="DeskWeather-ForeCast-info-value">'+((this.units == 'english')? o[4].tmp.hi.english : o[4].tmp.hi.metric )+'</span></p><p class="DeskWeather-ForeCast-info-libel">'+DeskWeatherLocalString.InfoChanceOfRain+'<span class="DeskWeather-ForeCast-info-value">'+o[4].ppcp+'</span></p><p class="DeskWeather-ForeCast-info-libel">'+DeskWeatherLocalString.InfoHumidity+'<span class="DeskWeather-ForeCast-info-value">'+o[4].humidity+'</span></p></div></td></tr></table>',
      cls : 'DeskWeather-ForeCast',
      width: 300
    });
    },

      showConf: function() {

            var winConf = new Ext.Window({
                layout:'fit',
                width:415,
                height:200,
                iconCls: 'DeskWeather-icon',
                modal: true,
                closeAction:'close',
                title: DeskWeatherLocalString.ConfCityTitle,
                bodyStyle:'color:#000; padding:5px;',
                plain: true,

                items: new Ext.FormPanel({
                    border:false,
                    id:'DeskWeather-form-'+this.IdentCity,
                    autoHeight: true,
                    defaults: {autoScroll: true,bodyStyle:'padding:5px'},
                    items: [{
                        xtype:'fieldset',
                        autoHeight: true,
                        title: DeskWeatherLocalString.ConfCityUnits,
                        bodyStyle:'padding:5px',
                        items:[{
                                xtype:'radio',
                                id:'DeskWeather-form-'+this.IdentCity+'-units-metric',
                                boxLabel : DeskWeatherLocalString.ConfCityMetric,
                                name:'units',
                                hideLabel :true,
                                inputValue:'metric'
                        },{
                                xtype:'radio',
                                id:'DeskWeather-form-'+this.IdentCity+'-units-english',
                                boxLabel : DeskWeatherLocalString.ConfCityEnglish,
                                name:'units',
                                hideLabel :true,
                                inputValue:'english'
                        }

                        ]
                    },{
                        xtype:'checkbox',
                        id:'DeskWeather-form-'+this.IdentCity+'-saveInDB',
                        name:'saveDB',
                        boxLabel :DeskWeatherLocalString.ConfCitySaveInDB,
                        hideLabel : true
                    }]
                }),

                buttons: [{
                    scope: this,
                    text: DeskWeatherLocalString.ConfCitySave,
                    handler: function() {


                        Ext.getCmp('DeskWeather-form-'+this.IdentCity).form.submit({
                        url: this.app.connection,
                        scope: this,
                        params: {
                                moduleId: 'desk-weather',
                                fileName: 'php/save-city.php',
                                identCity: this.IdentCity,
                                libelCity: this.LibelCity
                        },
                        success: function(form, action) {
                                this.units = action.result.units;

                                if( action.result.saveDB == 'on' ) { this.fromWhere = 'fromDB'; }
                                else { this.fromWhere = 'fromSearch'; }

                                this.loadData();
                                winConf.close();
                        }

                        });
                    }


                },{
                    scope: this,
                    text: DeskWeatherLocalString.AboutClose,
                    handler: function() {
                        winConf.close();
                    }
                }]
            });

	    if( this.units == 'english' ) {
	       Ext.getCmp('DeskWeather-form-'+this.IdentCity+'-units-english').setValue(true);
	    } else {
	       Ext.getCmp('DeskWeather-form-'+this.IdentCity+'-units-metric').setValue(true);
	    }

	    if( this.fromWhere == 'fromDB' ) { Ext.getCmp('DeskWeather-form-'+this.IdentCity+'-saveInDB').setValue(true); }

        winConf.show(this);

  } //showConf




});

QoDesk.DeskWeather = Ext.extend(Ext.app.Module, {

  moduleType : 'weather',
  moduleId : 'desk-weather',
  menuPath : 'StartMenu/Internet',

  init: function(){
    this.launcher = {
      text: DeskWeatherLocalString.TitleMainPanel,
      iconCls: 'DeskWeather-icon',
      handler: this.createWindow,
      scope: this,
      shortcutIconCls: 'DeskWeather-shortcut-icon',
      tooltip: '<b>'+DeskWeatherLocalString.TitleMainPanel+'</b><br />Display City weather over the world !'
    };
  },

  createWindow: function(app){

    var desktop = this.app.getDesktop();
    var win = desktop.getWindow('desk-weather');

    if (!win) {

        this.loadCity();

        var dsSearch = new Ext.data.Store({
                proxy: new Ext.data.HttpProxy({
                    url: this.app.connection+'?moduleId='+this.moduleId+'&fileName=php/search-location.php'
                }),
                reader: new Ext.data.JsonReader({
                    root:'items',
                    id:'ident'
                }, [
                    {name: 'ident'},
                    {name: 'city'}
                ])
        });

        dsSearch.on('load', function(ds, record) {

        // If there's no record, blank view
        if( !record ) {

                Ext.MessageBox.show({
                   title: DeskWeatherLocalString.SearchNoResult,
                   msg: DeskWeatherLocalString.SearchNoResult,
                   buttons: Ext.MessageBox.OK,
                   icon: Ext.MessageBox.INFO
               });

                Ext.getCmp('desk-weather-result-search').refresh();

        }

        }, this);

            // Custom rendering Template for the View
            var resultTpl = new Ext.XTemplate(
                '<tpl for=".">',
                  '<div class="city-wrap">',
                      '<div class="city">{city}</div>',
                  '</div>',
                '</tpl>'
            );

        var searchPanel = new Ext.Panel({
        height:235,
        autoScroll:true,

        items: new Ext.DataView({
            tpl: resultTpl,
            id : 'desk-weather-result-search',
            store: dsSearch,
            itemSelector: 'div.city-wrap',
            overClass:'x-view-over',
            singleSelect: true
        }),

        tbar: [new Ext.ux.DeskWeatherSearchField({
                store: dsSearch,
                width:218,
                emptyText:DeskWeatherLocalString.SearchTitle
            })
        ]
    });

        win = desktop.createWindow({
                id: 'desk-weather',
                title: DeskWeatherLocalString.TitleMainPanel,
                width: 250,
                height: 316,
                x: desktop.getWinX(250),
                y: desktop.getWinY(316),
                iconCls: 'DeskWeather-icon',
                shim: false,
                animCollapse: false,
                constrainHeader: false,
                minimizable: true,
                maximizable: false,
                resizable: false,
                layout: 'border',
                tools:[{
                        scope: this,
                        id:'help',
                        qtip:'About',
                        handler: this.showAbout
                }],
                items: [{
                    region: 'center',
                    id:'center-panel',
                    bodyStyle: 'padding:5px;',
                    items : searchPanel
                  }],
                buttons: [{
                    scope: this,
                    id: 'btn-get',
                    disabled:true,
                    text: DeskWeatherLocalString.SearchDisplay,
                    handler: function(){
                        var indexSearch = Ext.getCmp('desk-weather-result-search').getSelectedIndexes();

                        var win = new QoDesk.DeskWeatherCity({id:'desk-weather-local-win-'+dsSearch.getAt(indexSearch).data.ident});
                        var detailWin = win.createWindow(this.app, dsSearch.getAt(indexSearch).data.ident, dsSearch.getAt(indexSearch).data.city,'fromSearch');

                    }
                }]

                });

        Ext.getCmp('desk-weather-result-search').on('click', function() { Ext.getCmp('btn-get').enable(); }, this);

    } //win

    win.show();

    // Enable onDblClick view
    Ext.getCmp('desk-weather-result-search').on('dblclick', function(view, NumIndex,node,e) {

      var win = new QoDesk.DeskWeatherCity({id:'desk-weather-local-win-'+dsSearch.getAt(NumIndex).data.ident});
      var detailWin = win.createWindow(this.app, dsSearch.getAt(NumIndex).data.ident, dsSearch.getAt(NumIndex).data.city,'fromSearch');

    }, this);

    },

  showAbout: function(){

        if(!this.winAbout) {
            this.winAbout = new Ext.Window({
                layout:'fit',
                width:425,
                height:260,
                iconCls: 'DeskWeather-icon',
                modal: true,
                closeAction:'hide',
                title: DeskWeatherLocalString.AboutTitle,
                bodyStyle:'color:#000',
                plain: true,

                items: new Ext.TabPanel({
                    autoTabs:true,
                    activeTab:0,
                    border:false,
        defaults: {
          autoScroll: true
        },
    items: [{
        title: DeskWeatherLocalString.AboutTab0,
        html: '<div id="DeskWeather-about"><img src="system/modules/Desk-Weather/img/logo.png" alt="" /></div><div id="DeskWeather-about-info">(c) 2008, Yannick Torr&egrave;s - <a href="mailto:yannick.torres@keliglia.com">yannick.torres@keliglia.com</a></div>'
    },{
        title: DeskWeatherLocalString.AboutTab1,
        bodyStyle:'padding:5px',
        html: '<div id="DeskWeather-credit"><ul><li><a href="http://extjs.com/forum/member.php?u=12208">Franck Carrouget</a><br><span class="DeskWeather-credit-info">'+DeskWeatherLocalString.AboutTab1Credits0+'</span></li><li><a href="http://weather.com/">Weather.com</a></li><li><a href="http://extjs.com">ExtJs Team</a><br><span class="DeskWeather-credit-info">'+DeskWeatherLocalString.AboutTab1Credits3+'</span></li></ul></div>'
    },{
        title: DeskWeatherLocalString.AboutTab2,
        bodyStyle:'padding:5px',
        autoLoad: {url: 'system/modules/Desk-Weather/license_LGPL_v2.txt'}
    }]
                }),

                buttons: [{
                    scope: this,
                    text: DeskWeatherLocalString.AboutClose,
                    handler: function(){
                        this.winAbout.hide();
                    }
                }]
            });
        }
        this.winAbout.show(this);

  }, //showAbout


    loadCity : function() {

       var saveDataConnexion = new Ext.data.Connection();
       saveDataConnexion.request({
           scope: this,
           url: this.app.connection,
           params: {
                 moduleId: this.moduleId,
                 fileName: 'php/load-city.php'
           },

           success: function(response, options) {

            var o = Ext.util.JSON.decode(response.responseText);

            if( o.nb > 0 ) {
              for( i=0; i < o.nb; i++ ) {

                var win = new QoDesk.DeskWeatherCity({id:'desk-weather-local-win-'+o.result[i].identCity});
                var detailWin = win.createWindow(this.app, o.result[i].identCity, o.result[i].libelCity, o.result[i].units, 'fromDB');


              }
            }

           }

       });

    }

});
